#ifdef GL_HERETIC

//#define __DOOMTYPE__

#include <stdio.h>
#include <Malloc.h>
#include <string.h>
#include <windows.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "gl_struct.h"
#include "gl_mem.h"
#include "md2.h"

#ifndef GL_HEXEN
#include "doomdef.h"
#else
#include "h2def.h"
#endif
#include "r_local.h"
#include "p_spec.h"

extern H_boolean g_bMD2;
extern int *g_a_iTexMD2;
extern int g_iModel,g_iTex;
H_boolean g_bMD2Interpol;

//#ifdef DOOM_GL
#if 1
//#define NB_MD2 6	// in md2.h
extern float *fMD2Scale;
#define NUMMD2STATES (NUMSTATES/2)
char **MD2_FileName;
char **MD2_WFileName;
float *fMD2offset;
md2_model_t **Models;
md2_model_t **WModels;
MD2StateTable GlobalMD2Table[NUMMD2STATES];
//MD2CorrespTable CorrespMD2Table[NUMSTATES];
/*char MD2_FileName[NB_MD2][64]=
{	//"md2\\tris.md2",
	"md2\\imp.md2",
	"md2\\soldier2.md2",
//	"imp\\soldier.md2",
	"md2\\sargeant.md2",
	"md2\\pinky.md2",
	"md2\\baron.md2",
	"md2\\qcaco.md2",
	"md2\\cyber.md2",
	"md2\\spider.md2",
	"md2\\chainer.md2",
	"md2\\arach.md2",
	"md2\\archv.md2",
	"md2\\macum.md2",
	"md2\\revenant.md2"
};
float fMD2offset[NB_MD2]=
{	//23.0f,
	27.0f,
	23.0f,
	23.0f,
	0.0f,
	0.0f,
	30.0f,
	23.0f,
	0.0f,
	0.0f,
	0.0f,
	0.0f,
	0.0f,
	0.0f
};

md2_model_t *Models[NB_MD2];

#define NB_MD2_STATES 75
MD2StateTable GlobalMD2Table[NB_MD2_STATES]=
{
// imp.md2	
	{ 0,"wait",0,0,0 },		// MD2_TROO_STND
	{ 0,"walk",0,0,0 },		// MD2_TROO_RUN
	{ 0,"attack",0,0,0 },	// MD2_TROO_ATK
	{ 0,"pain",0,0,0 },		// MD2_TROO_PAIN
	{ 0,"death",0,0,0 },	// MD2_TROO_DIE
	{ 0,"die",1,28,28 },	// MD2_TROO_DIE2
// soldier2.md2
	{ 1,"stand",0,0,0 },	// MD2_POSS_STND
	{ 1,"walk",0,0,0 },		// MD2_POSS_RUN
	{ 1,"fire",0,0,0 },		// MD2_POSS_ATK
	{ 1,"pain",0,0,0 },		// MD2_POSS_PAIN
	{ 1,"die",0,0,0 },		// MD2_POSS_DIE
	{ 1,"die",1,82,82 },	// MD2_POSS_DIE2
// sargeant.md2
	{ 2,"wait",0,0,0 },		// MD2_SPOS_STND
	{ 2,"walk",0,0,0 },		// MD2_SPOS_RUN
	{ 2,"shoot",0,0,0 },	// MD2_SPOS_ATK
	{ 2,"pain",0,0,0 },		// MD2_SPOS_PAIN
	{ 2,"death",0,0,0 },	// MD2_SPOS_DIE
	{ 2,"death",1,32,32 },	// MD2_SPOS_DIE2
// pinky.md2
	{ 3,"walk",1,39,39 },	// MD2_SARG_STND
	{ 3,"walk",0,0,0 },		// MD2_SARG_RUN
	{ 3,"bite",0,0,0 },		// MD2_SARG_ATK
	{ 3,"death",4,6,9 },	// MD2_SARG_PAIN
	{ 3,"death",0,0,0 },	// MD2_SARG_DIE
	{ 3,"death",1,30,30 },	// MD2_SARG_DIE2
// baron.md2
	{ 4,"stand",0,0,0 },	// MD2_BOSS_STND
	{ 4,"walk",0,0,0 },		// MD2_BOSS_RUN
	{ 4,"shoot",0,0,0 },	// MD2_BOSS_ATK
	{ 4,"paina",0,0,0 },	// MD2_BOSS_PAIN
	{ 4,"death",0,0,0 },	// MD2_BOSS_DIE
	{ 4,"death",1,190,190 },// MD2_BOSS_DIE2
// qcaco.md2
	{ 5,"pain",1,1,1 },		// MD2_HEAD_STND
	{ 5,"pain",1,1,1 },		// MD2_HEAD_RUN
	{ 5,"attack",0,0,0 },	// MD2_HEAD_ATK
	{ 5,"pain",0,0,0 },		// MD2_HEAD_PAIN
	{ 5,"death",0,0,0 },	// MD2_HEAD_DIE
	{ 5,"death",1,27,27 },	// MD2_HEAD_DIE2
// cyber.md2
	{ 6,"stand",0,0,0 },	// MD2_CYBER_STND
	{ 6,"walk",0,0,0 },		// MD2_CYBER_RUN
	{ 6,"shoot",0,0,0 },	// MD2_CYBER_ATK
	{ 6,"walk",1,6,6 },		// MD2_CYBER_PAIN
// spider.md2
	{ 7,"stand",0,0,0 },	// MD2_SPID_STND
	{ 7,"walk",0,0,0 },		// MD2_SPID_RUN
	{ 7,"fire",0,0,0 },		// MD2_SPID_ATK
	{ 7,"pain",0,0,0 },		// MD2_SPID_PAIN
// chainer.md2
	{ 8,"walk",1,26,26 },	// MD2_CPOS_STND
	{ 8,"walk",0,0,0 },		// MD2_CPOS_RUN
	{ 8,"shoot",0,0,0 },	// MD2_CPOS_ATK
	{ 8,"death",4,2,5 },	// MD2_CPOS_PAIN
	{ 8,"death",0,0,0 },	// MD2_CPOS_DIE
	{ 8,"death",1,20,20 },	// MD2_CPOS_DIE2
// arach.md2
	{ 9,"stand",0,0,0 },	// MD2_BSPI_STND
	{ 9,"fire",1,0,0 },		// MD2_BSPI_SIGHT
	{ 9,"walk",0,0,0 },		// MD2_BSPI_RUN
	{ 9,"fire",0,0,0 },		// MD2_BSPI_ATK
	{ 9,"pain",0,0,0 },		// MD2_BSPI_PAIN
// archv.md2
	{ 10,"walk",1,4,4 },	// MD2_VILE_STND
	{ 10,"walk",0,0,0 },	// MD2_VILE_RUN
	{ 10,"attack",0,0,0 },	// MD2_VILE_ATK
	{ 10,"pain",0,0,0 },	// MD2_VILE_PAIN
	{ 10,"death",0,0,0 },	// MD2_VILE_DIE
	{ 10,"death",1,83,83 },	// MD2_VILE_DIE2
	{ 10,"ressurection",0,0,0 },	// MD2_VILE_HEAL
// macum.md2
	{ 11,"walk",3,16,18 },	// MD2_FATT_STND
	{ 11,"walk",0,0,0 },	// MD2_FATT_RUN
	{ 11,"shoot",0,0,0 },	// MD2_FATT_ATK
	{ 11,"pain",0,0,0 },	// MD2_FATT_PAIN
	{ 11,"death",0,0,0 },	// MD2_FATT_DIE
	{ 11,"death",1,62,62 },	// MD2_FATT_DIE2
// revenant.md2
	{ 12,"walk",3,30,32 },	// MD2_SKEL_STND
	{ 12,"walk",0,0,0 },	// MD2_SKEL_RUN
	{ 12,"punch",0,0,0 },	// MD2_SKEL_FIST
	{ 12,"shoot",0,0,0 },	// MD2_SKEL_MISS
	{ 12,"pain",0,0,0 },	// MD2_SKEL_PAIN
	{ 12,"death",0,0,0 },	// MD2_SKEL_DIE
	{ 12,"death",1,21,21 }	// MD2_SKEL_DIE2
};

#define NB_CORRESP_STATES 304
MD2CorrespTable CorrespMD2Table[NB_CORRESP_STATES]=
{
    { S_TROO_STND,	MD2_TROO_STND },
    { S_TROO_STND2, MD2_TROO_STND },
    { S_TROO_RUN1, MD2_TROO_RUN },
    { S_TROO_RUN2, MD2_TROO_RUN },
    { S_TROO_RUN3, MD2_TROO_RUN },
    { S_TROO_RUN4, MD2_TROO_RUN },
    { S_TROO_RUN5, MD2_TROO_RUN },
    { S_TROO_RUN6, MD2_TROO_RUN },
    { S_TROO_RUN7, MD2_TROO_RUN },
    { S_TROO_RUN8, MD2_TROO_RUN },
    { S_TROO_ATK1, MD2_TROO_ATK },
    { S_TROO_ATK2, MD2_TROO_ATK },
    { S_TROO_ATK3, MD2_TROO_ATK },
    { S_TROO_PAIN, MD2_TROO_PAIN },
    { S_TROO_PAIN2, MD2_TROO_PAIN },
    { S_TROO_DIE1, MD2_TROO_DIE },
    { S_TROO_DIE2, MD2_TROO_DIE },
    { S_TROO_DIE3, MD2_TROO_DIE },
    { S_TROO_DIE4, MD2_TROO_DIE },
    { S_TROO_DIE5, MD2_TROO_DIE2 },
    { S_POSS_STND, MD2_POSS_STND },
    { S_POSS_STND2, MD2_POSS_STND },
    { S_POSS_RUN1, MD2_POSS_RUN },
    { S_POSS_RUN2, MD2_POSS_RUN },
    { S_POSS_RUN3, MD2_POSS_RUN },
    { S_POSS_RUN4, MD2_POSS_RUN },
    { S_POSS_RUN5, MD2_POSS_RUN },
    { S_POSS_RUN6, MD2_POSS_RUN },
    { S_POSS_RUN7, MD2_POSS_RUN },
    { S_POSS_RUN8, MD2_POSS_RUN },
    { S_POSS_ATK1, MD2_POSS_ATK },
    { S_POSS_ATK2, MD2_POSS_ATK },
    { S_POSS_ATK3, MD2_POSS_ATK },
    { S_POSS_PAIN, MD2_POSS_PAIN },
    { S_POSS_PAIN2, MD2_POSS_PAIN },
    { S_POSS_DIE1, MD2_POSS_DIE },
    { S_POSS_DIE2, MD2_POSS_DIE },
    { S_POSS_DIE3, MD2_POSS_DIE },
    { S_POSS_DIE4, MD2_POSS_DIE },
    { S_POSS_DIE5, MD2_POSS_DIE2 },
    { S_SPOS_STND, MD2_SPOS_STND },
    { S_SPOS_STND2, MD2_SPOS_STND },
    { S_SPOS_RUN1, MD2_SPOS_RUN },
    { S_SPOS_RUN2, MD2_SPOS_RUN },
    { S_SPOS_RUN3, MD2_SPOS_RUN },
    { S_SPOS_RUN4, MD2_SPOS_RUN },
    { S_SPOS_RUN5, MD2_SPOS_RUN },
    { S_SPOS_RUN6, MD2_SPOS_RUN },
    { S_SPOS_RUN7, MD2_SPOS_RUN },
    { S_SPOS_RUN8, MD2_SPOS_RUN },
    { S_SPOS_ATK1, MD2_SPOS_ATK },
    { S_SPOS_ATK2, MD2_SPOS_ATK },
    { S_SPOS_ATK3, MD2_SPOS_ATK },
    { S_SPOS_PAIN, MD2_SPOS_PAIN },
    { S_SPOS_PAIN2, MD2_SPOS_PAIN },
    { S_SPOS_DIE1, MD2_SPOS_DIE },
    { S_SPOS_DIE2, MD2_SPOS_DIE },
    { S_SPOS_DIE3, MD2_SPOS_DIE },
    { S_SPOS_DIE4, MD2_SPOS_DIE },
    { S_SPOS_DIE5, MD2_SPOS_DIE2 },
    { S_SARG_STND, MD2_SARG_STND },
    { S_SARG_STND2, MD2_SARG_STND },
    { S_SARG_RUN1, MD2_SARG_RUN },
    { S_SARG_RUN2, MD2_SARG_RUN },
    { S_SARG_RUN3, MD2_SARG_RUN },
    { S_SARG_RUN4, MD2_SARG_RUN },
    { S_SARG_RUN5, MD2_SARG_RUN },
    { S_SARG_RUN6, MD2_SARG_RUN },
    { S_SARG_RUN7, MD2_SARG_RUN },
    { S_SARG_RUN8, MD2_SARG_RUN },
    { S_SARG_ATK1, MD2_SARG_ATK },
    { S_SARG_ATK2, MD2_SARG_ATK },
    { S_SARG_ATK3, MD2_SARG_ATK },
    { S_SARG_PAIN, MD2_SARG_PAIN },
    { S_SARG_PAIN2, MD2_SARG_PAIN },
    { S_SARG_DIE1, MD2_SARG_DIE },
    { S_SARG_DIE2, MD2_SARG_DIE },
    { S_SARG_DIE3, MD2_SARG_DIE },
    { S_SARG_DIE4, MD2_SARG_DIE },
    { S_SARG_DIE5, MD2_SARG_DIE },
    { S_SARG_DIE6, MD2_SARG_DIE2 },
    { S_BOSS_STND, MD2_BOSS_STND },
    { S_BOSS_STND2, MD2_BOSS_STND },
    { S_BOSS_RUN1, MD2_BOSS_RUN },
    { S_BOSS_RUN2, MD2_BOSS_RUN },
    { S_BOSS_RUN3, MD2_BOSS_RUN },
    { S_BOSS_RUN4, MD2_BOSS_RUN },
    { S_BOSS_RUN5, MD2_BOSS_RUN },
    { S_BOSS_RUN6, MD2_BOSS_RUN },
    { S_BOSS_RUN7, MD2_BOSS_RUN },
    { S_BOSS_RUN8, MD2_BOSS_RUN },
    { S_BOSS_ATK1, MD2_BOSS_ATK },
    { S_BOSS_ATK2, MD2_BOSS_ATK },
    { S_BOSS_ATK3, MD2_BOSS_ATK },
    { S_BOSS_PAIN, MD2_BOSS_PAIN },
    { S_BOSS_PAIN2, MD2_BOSS_PAIN },
    { S_BOSS_DIE1, MD2_BOSS_DIE },
    { S_BOSS_DIE2, MD2_BOSS_DIE },
    { S_BOSS_DIE3, MD2_BOSS_DIE },
    { S_BOSS_DIE4, MD2_BOSS_DIE },
    { S_BOSS_DIE5, MD2_BOSS_DIE },
    { S_BOSS_DIE6, MD2_BOSS_DIE },
    { S_BOSS_DIE7, MD2_BOSS_DIE2 },
    { S_HEAD_STND, MD2_HEAD_STND },
    { S_HEAD_RUN1, MD2_HEAD_RUN },
    { S_HEAD_ATK1, MD2_HEAD_ATK },
    { S_HEAD_ATK2, MD2_HEAD_ATK },
    { S_HEAD_ATK3, MD2_HEAD_ATK },
    { S_HEAD_PAIN, MD2_HEAD_PAIN },
    { S_HEAD_PAIN2, MD2_HEAD_PAIN },
    { S_HEAD_PAIN3, MD2_HEAD_PAIN },
    { S_HEAD_DIE1, MD2_HEAD_DIE },
    { S_HEAD_DIE2, MD2_HEAD_DIE },
    { S_HEAD_DIE3, MD2_HEAD_DIE },
    { S_HEAD_DIE4, MD2_HEAD_DIE },
    { S_HEAD_DIE5, MD2_HEAD_DIE },
    { S_HEAD_DIE6, MD2_HEAD_DIE2 },
    { S_CYBER_STND, MD2_CYBER_STND },
    { S_CYBER_STND2, MD2_CYBER_STND },
    { S_CYBER_RUN1, MD2_CYBER_RUN },
    { S_CYBER_RUN2, MD2_CYBER_RUN },
    { S_CYBER_RUN3, MD2_CYBER_RUN },
    { S_CYBER_RUN4, MD2_CYBER_RUN },
    { S_CYBER_RUN5, MD2_CYBER_RUN },
    { S_CYBER_RUN6, MD2_CYBER_RUN },
    { S_CYBER_RUN7, MD2_CYBER_RUN },
    { S_CYBER_RUN8, MD2_CYBER_RUN },
    { S_CYBER_ATK1, MD2_CYBER_ATK },
    { S_CYBER_ATK2, MD2_CYBER_ATK },
    { S_CYBER_ATK3, MD2_CYBER_ATK },
    { S_CYBER_ATK4, MD2_CYBER_ATK },
    { S_CYBER_ATK5, MD2_CYBER_ATK },
    { S_CYBER_ATK6, MD2_CYBER_ATK },
    { S_CYBER_PAIN, MD2_CYBER_PAIN },
    { S_SPID_STND, MD2_SPID_STND },
    { S_SPID_STND2, MD2_SPID_STND },
    { S_SPID_RUN1, MD2_SPID_RUN },
    { S_SPID_RUN2, MD2_SPID_RUN },
    { S_SPID_RUN3, MD2_SPID_RUN },
    { S_SPID_RUN4, MD2_SPID_RUN },
    { S_SPID_RUN5, MD2_SPID_RUN },
    { S_SPID_RUN6, MD2_SPID_RUN },
    { S_SPID_RUN7, MD2_SPID_RUN },
    { S_SPID_RUN8, MD2_SPID_RUN },
    { S_SPID_RUN9, MD2_SPID_RUN },
    { S_SPID_RUN10, MD2_SPID_RUN },
    { S_SPID_RUN11, MD2_SPID_RUN },
    { S_SPID_RUN12, MD2_SPID_RUN },
    { S_SPID_ATK1, MD2_SPID_ATK },
    { S_SPID_ATK2, MD2_SPID_ATK },
    { S_SPID_ATK3, MD2_SPID_ATK },
    { S_SPID_ATK4, MD2_SPID_ATK },
    { S_SPID_PAIN, MD2_SPID_PAIN },
    { S_SPID_PAIN2, MD2_SPID_PAIN },
    { S_CPOS_STND, MD2_CPOS_STND },
    { S_CPOS_STND2, MD2_CPOS_STND },
    { S_CPOS_RUN1, MD2_CPOS_RUN },
    { S_CPOS_RUN2, MD2_CPOS_RUN },
    { S_CPOS_RUN3, MD2_CPOS_RUN },
    { S_CPOS_RUN4, MD2_CPOS_RUN },
    { S_CPOS_RUN5, MD2_CPOS_RUN },
    { S_CPOS_RUN6, MD2_CPOS_RUN },
    { S_CPOS_RUN7, MD2_CPOS_RUN },
    { S_CPOS_RUN8, MD2_CPOS_RUN },
    { S_CPOS_ATK1, MD2_CPOS_ATK },
    { S_CPOS_ATK2, MD2_CPOS_ATK },
    { S_CPOS_ATK3, MD2_CPOS_ATK },
    { S_CPOS_ATK4, MD2_CPOS_ATK },
    { S_CPOS_PAIN, MD2_CPOS_PAIN },
    { S_CPOS_PAIN2, MD2_CPOS_PAIN },
    { S_CPOS_DIE1, MD2_CPOS_DIE },
    { S_CPOS_DIE2, MD2_CPOS_DIE },
    { S_CPOS_DIE3, MD2_CPOS_DIE },
    { S_CPOS_DIE4, MD2_CPOS_DIE },
    { S_CPOS_DIE5, MD2_CPOS_DIE },
    { S_CPOS_DIE6, MD2_CPOS_DIE },
    { S_CPOS_DIE7, MD2_CPOS_DIE2 },
    { S_BSPI_STND, MD2_BSPI_STND },
    { S_BSPI_STND2, MD2_BSPI_STND },
    { S_BSPI_SIGHT, MD2_BSPI_SIGHT },
    { S_BSPI_RUN1, MD2_BSPI_RUN },
    { S_BSPI_RUN2, MD2_BSPI_RUN },
    { S_BSPI_RUN3, MD2_BSPI_RUN },
    { S_BSPI_RUN4, MD2_BSPI_RUN },
    { S_BSPI_RUN5, MD2_BSPI_RUN },
    { S_BSPI_RUN6, MD2_BSPI_RUN },
    { S_BSPI_RUN7, MD2_BSPI_RUN },
    { S_BSPI_RUN8, MD2_BSPI_RUN },
    { S_BSPI_RUN9, MD2_BSPI_RUN },
    { S_BSPI_RUN10, MD2_BSPI_RUN },
    { S_BSPI_RUN11, MD2_BSPI_RUN },
    { S_BSPI_RUN12, MD2_BSPI_RUN },
    { S_BSPI_ATK1, MD2_BSPI_ATK },
    { S_BSPI_ATK2, MD2_BSPI_ATK },
    { S_BSPI_ATK3, MD2_BSPI_ATK },
    { S_BSPI_ATK4, MD2_BSPI_ATK },
    { S_BSPI_PAIN, MD2_BSPI_PAIN },
    { S_BSPI_PAIN2, MD2_BSPI_PAIN },
    { S_VILE_STND, MD2_VILE_STND },
    { S_VILE_STND2, MD2_VILE_STND },
    { S_VILE_RUN1, MD2_VILE_RUN },
    { S_VILE_RUN2, MD2_VILE_RUN },
    { S_VILE_RUN3, MD2_VILE_RUN },
    { S_VILE_RUN4, MD2_VILE_RUN },
    { S_VILE_RUN5, MD2_VILE_RUN },
    { S_VILE_RUN6, MD2_VILE_RUN },
    { S_VILE_RUN7, MD2_VILE_RUN },
    { S_VILE_RUN8, MD2_VILE_RUN },
    { S_VILE_RUN9, MD2_VILE_RUN },
    { S_VILE_RUN10, MD2_VILE_RUN },
    { S_VILE_RUN11, MD2_VILE_RUN },
    { S_VILE_RUN12, MD2_VILE_RUN },
    { S_VILE_ATK1, MD2_VILE_ATK },
    { S_VILE_ATK2, MD2_VILE_ATK },
    { S_VILE_ATK3, MD2_VILE_ATK },
    { S_VILE_ATK4, MD2_VILE_ATK },
    { S_VILE_ATK5, MD2_VILE_ATK },
    { S_VILE_ATK6, MD2_VILE_ATK },
    { S_VILE_ATK7, MD2_VILE_ATK },
    { S_VILE_ATK8, MD2_VILE_ATK },
    { S_VILE_ATK9, MD2_VILE_ATK },
    { S_VILE_ATK10, MD2_VILE_ATK },
    { S_VILE_ATK11, MD2_VILE_ATK },
    { S_VILE_HEAL1, MD2_VILE_HEAL },
    { S_VILE_HEAL2, MD2_VILE_HEAL },
    { S_VILE_HEAL3, MD2_VILE_HEAL },
    { S_VILE_PAIN, MD2_VILE_PAIN },
    { S_VILE_PAIN2, MD2_VILE_PAIN },
    { S_VILE_DIE1, MD2_VILE_DIE },
    { S_VILE_DIE2, MD2_VILE_DIE },
    { S_VILE_DIE3, MD2_VILE_DIE },
    { S_VILE_DIE4, MD2_VILE_DIE },
    { S_VILE_DIE5, MD2_VILE_DIE },
    { S_VILE_DIE6, MD2_VILE_DIE },
    { S_VILE_DIE7, MD2_VILE_DIE },
    { S_VILE_DIE8, MD2_VILE_DIE },
    { S_VILE_DIE9, MD2_VILE_DIE },
    { S_VILE_DIE10, MD2_VILE_DIE2 },
    { S_FATT_STND, MD2_FATT_STND },
    { S_FATT_STND2, MD2_FATT_STND },
    { S_FATT_RUN1, MD2_FATT_RUN },
    { S_FATT_RUN2, MD2_FATT_RUN },
    { S_FATT_RUN3, MD2_FATT_RUN },
    { S_FATT_RUN4, MD2_FATT_RUN },
    { S_FATT_RUN5, MD2_FATT_RUN },
    { S_FATT_RUN6, MD2_FATT_RUN },
    { S_FATT_RUN7, MD2_FATT_RUN },
    { S_FATT_RUN8, MD2_FATT_RUN },
    { S_FATT_RUN9, MD2_FATT_RUN },
    { S_FATT_RUN10, MD2_FATT_RUN },
    { S_FATT_RUN11, MD2_FATT_RUN },
    { S_FATT_RUN12, MD2_FATT_RUN },
    { S_FATT_ATK1, MD2_FATT_ATK },
    { S_FATT_ATK2, MD2_FATT_ATK },
    { S_FATT_ATK3, MD2_FATT_ATK },
    { S_FATT_ATK4, MD2_FATT_ATK },
    { S_FATT_ATK5, MD2_FATT_ATK },
    { S_FATT_ATK6, MD2_FATT_ATK },
    { S_FATT_ATK7, MD2_FATT_ATK },
    { S_FATT_ATK8, MD2_FATT_ATK },
    { S_FATT_ATK9, MD2_FATT_ATK },
    { S_FATT_ATK10, MD2_FATT_ATK },
    { S_FATT_PAIN, MD2_FATT_PAIN },
    { S_FATT_PAIN2, MD2_FATT_PAIN },
    { S_FATT_DIE1, MD2_FATT_DIE },
    { S_FATT_DIE2, MD2_FATT_DIE },
    { S_FATT_DIE3, MD2_FATT_DIE },
    { S_FATT_DIE4, MD2_FATT_DIE },
    { S_FATT_DIE5, MD2_FATT_DIE },
    { S_FATT_DIE6, MD2_FATT_DIE },
    { S_FATT_DIE7, MD2_FATT_DIE },
    { S_FATT_DIE8, MD2_FATT_DIE },
    { S_FATT_DIE9, MD2_FATT_DIE },
    { S_FATT_DIE10, MD2_FATT_DIE2 },
    { S_SKEL_STND, MD2_SKEL_STND },
    { S_SKEL_STND2, MD2_SKEL_STND },
    { S_SKEL_RUN1, MD2_SKEL_RUN },
    { S_SKEL_RUN2, MD2_SKEL_RUN },
    { S_SKEL_RUN3, MD2_SKEL_RUN },
    { S_SKEL_RUN4, MD2_SKEL_RUN },
    { S_SKEL_RUN5, MD2_SKEL_RUN },
    { S_SKEL_RUN6, MD2_SKEL_RUN },
    { S_SKEL_RUN7, MD2_SKEL_RUN },
    { S_SKEL_RUN8, MD2_SKEL_RUN },
    { S_SKEL_RUN9, MD2_SKEL_RUN },
    { S_SKEL_RUN10, MD2_SKEL_RUN },
    { S_SKEL_RUN11, MD2_SKEL_RUN },
    { S_SKEL_RUN12, MD2_SKEL_RUN },
    { S_SKEL_FIST1, MD2_SKEL_FIST },
    { S_SKEL_FIST2, MD2_SKEL_FIST },
    { S_SKEL_FIST3, MD2_SKEL_FIST },
    { S_SKEL_FIST4, MD2_SKEL_FIST },
    { S_SKEL_MISS1, MD2_SKEL_MISS },
    { S_SKEL_MISS2, MD2_SKEL_MISS },
    { S_SKEL_MISS3, MD2_SKEL_MISS },
    { S_SKEL_MISS4, MD2_SKEL_MISS },
    { S_SKEL_PAIN, MD2_SKEL_PAIN },
    { S_SKEL_PAIN2, MD2_SKEL_PAIN },
    { S_SKEL_DIE1, MD2_SKEL_DIE },
    { S_SKEL_DIE2, MD2_SKEL_DIE },
    { S_SKEL_DIE3, MD2_SKEL_DIE },
    { S_SKEL_DIE4, MD2_SKEL_DIE },
    { S_SKEL_DIE5, MD2_SKEL_DIE },
    { S_SKEL_DIE6, MD2_SKEL_DIE2 }
};
#elif GL_HEXEN
char MD2_FileName[NB_MD2][64]=
{	
	"md2\\mal.md2"
};
float fMD2offset[NB_MD2]=
{	
	-5.0f
};

md2_model_t *Models[NB_MD2];

#define NB_MD2_STATES 7
MD2StateTable GlobalMD2Table[NB_MD2_STATES]=
{
// mal.md2	
	{ 0,"idle",0,0,0 },			// MD2_MNTR_LOOK
	{ 0,"maulrn",0,0,0 },		// MD2_MNTR_WALK
	{ 0,"maulsw",0,0,0 },		// MD2_MNTR_ATK1
	{ 0,"maulat",29,57,70 },	// MD2_MNTR_ATK3
	{ 0,"maulat",17,39,56 },	// MD2_MNTR_ATK4
	{ 0,"maulpn",0,0,0 },		// MD2_MNTR_PAIN
	{ 0,"mauldt",0,0,0 },		// MD2_MNTR_DIE
};

#define NB_CORRESP_STATES 35
MD2CorrespTable CorrespMD2Table[NB_CORRESP_STATES]=
{
    { S_MNTR_SPAWN1, MD2_MNTR_LOOK },
    { S_MNTR_SPAWN2, MD2_MNTR_LOOK },
    { S_MNTR_SPAWN3, MD2_MNTR_LOOK },
    { S_MNTR_LOOK1, MD2_MNTR_LOOK },
    { S_MNTR_LOOK2, MD2_MNTR_LOOK },
    { S_MNTR_WALK1, MD2_MNTR_WALK },
    { S_MNTR_WALK2, MD2_MNTR_WALK },
    { S_MNTR_WALK3, MD2_MNTR_WALK },
    { S_MNTR_WALK4, MD2_MNTR_WALK },
    { S_MNTR_ROAM1, MD2_MNTR_WALK },
    { S_MNTR_ROAM2, MD2_MNTR_WALK },
    { S_MNTR_ROAM3, MD2_MNTR_WALK },
    { S_MNTR_ROAM4, MD2_MNTR_WALK },
    { S_MNTR_ATK1_1, MD2_MNTR_ATK1 },
    { S_MNTR_ATK1_2, MD2_MNTR_ATK1 },
    { S_MNTR_ATK1_3, MD2_MNTR_ATK1 },
    { S_MNTR_ATK2_1, MD2_MNTR_ATK1 },
    { S_MNTR_ATK2_2, MD2_MNTR_ATK1 },
    { S_MNTR_ATK2_3, MD2_MNTR_ATK1 },
    { S_MNTR_ATK3_1, MD2_MNTR_ATK3 },
    { S_MNTR_ATK3_2, MD2_MNTR_ATK3 },
    { S_MNTR_ATK3_3, MD2_MNTR_ATK3 },
    { S_MNTR_ATK3_4, MD2_MNTR_ATK3 },
    { S_MNTR_ATK4_1, MD2_MNTR_ATK4 },
    { S_MNTR_PAIN1, MD2_MNTR_PAIN },
	{ S_MNTR_PAIN2, MD2_MNTR_PAIN },
	{ S_MNTR_DIE1, MD2_MNTR_DIE },
	{ S_MNTR_DIE2, MD2_MNTR_DIE },
	{ S_MNTR_DIE3, MD2_MNTR_DIE },
	{ S_MNTR_DIE4, MD2_MNTR_DIE },
	{ S_MNTR_DIE5, MD2_MNTR_DIE },
	{ S_MNTR_DIE6, MD2_MNTR_DIE },
	{ S_MNTR_DIE7, MD2_MNTR_DIE },
	{ S_MNTR_DIE8, MD2_MNTR_DIE },
	{ S_MNTR_DIE9, MD2_MNTR_DIE }
};
#else	// DOOM_GL*/
#endif	// DOOM_GL

//void GL_vSetTics(mobj_t *mobj,MD2enum_t md2)
void GL_vSetTics(mobj_t *mobj,int md2)
{
//#ifdef DOOM_GL
//#if defined(DOOM_GL) || defined(GL_HEXEN)
//	mobj->tics=GlobalMD2Table->iNbTics;
	mobj->MD2tics=GlobalMD2Table[md2].iNbTics;
//#endif
}

extern float cosA,sinA,xC,yC,zC/*,LightLev*/;	// MR3006
void _md2_drawModel (md2_model_t *model, int frame,GLfloat fLightLevel,GLfloat fAlpha);
void _md2_drawModelg (md2_model_t *model, int frame,GLfloat fLightLevel,GLfloat fAlpha);
_md2_drawModelgi (md2_model_t *model, int frame1, int frame2, float pol,GLfloat fLightLevel,GLfloat fAlpha);
void (*GL_vDrawMD2)(mobj_t *pSpr,float fLightLevel);
extern int usecoronas;
void GL_AddCorona(int doomednum,float x,float y,float z,float fLightLevel);

void GL_vDrawMD2g(mobj_t *pSpr,float fLightLevel)
{ float xi,yi,zi,angle,fAlpha;
  int iFrame;
  md2_model_t *model,*wmodel;
  int iCoronaIdx;

//#ifdef DOOM_GL
//#if defined(DOOM_GL) || defined(GL_HEXEN)
	model=Models[GlobalMD2Table[pSpr->state->MD2].iMD2];
	wmodel=WModels[GlobalMD2Table[pSpr->state->MD2].iMD2];
	if (pSpr->MD2tics<0)	// anti-bug...
		pSpr->MD2tics=0;
	/*iFrame=GlobalMD2Table[pSpr->state->MD2].iFirstFrame+
		(int)((float)(GlobalMD2Table[pSpr->state->MD2].iNbTics-pSpr->MD2tics)*
			  (float)(GlobalMD2Table[pSpr->state->MD2].iLastFrame-GlobalMD2Table[pSpr->state->MD2].iFirstFrame)/(float)GlobalMD2Table[pSpr->state->MD2].iNbTics);*/
	iFrame=GlobalMD2Table[pSpr->state->MD2].iFirstFrame+
		(int)((float)(GlobalMD2Table[pSpr->state->MD2].iNbTics-pSpr->MD2tics)*GlobalMD2Table[pSpr->state->MD2].fFrameTicFactor);
	xi=-(float)pSpr->x/MAP_SCALE;
	//yi=((float)pSpr->z/*+(float)spritetopoffset[lump]*/)/MAP_SCALE/*+(float)3/(MAP_SCALE>>FRACBITS)*/;	// Why +2 ???
	//yi=(float)pSpr->z/MAP_SCALE+23.0f/MAP_COEFF;
	yi=(float)pSpr->z/MAP_SCALE+fMD2offset[GlobalMD2Table[pSpr->state->MD2].iMD2]/MAP_COEFF;	// 18
	zi=(float)pSpr->y/MAP_SCALE;

	angle=-180.0f+(float)(pSpr->angle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslatef(xi,yi,zi);
	glRotatef(angle,0.0f,1.0f,0.0f);

	//glBindTexture(GL_TEXTURE_2D,50000+GlobalMD2Table[pSpr->state->MD2].iMD2);
	glBindTexture(GL_TEXTURE_2D,50000+g_a_iTexMD2[GlobalMD2Table[pSpr->state->MD2].iMD2]);

	if(pSpr->flags&MF_SHADOW)
		//GL_StaticLight4f(fLightLevel,fLightLevel,fLightLevel,0.5f);
		fAlpha=0.5f;
	else
		//GL_StaticLight3f(fLightLevel,fLightLevel,fLightLevel);
		fAlpha=1.0f;

	// MR3006: DynLight
	cosA=cos(angle);
	sinA=sin(angle);
	xC=xi;
	yC=yi;
	zC=zi;
	//LightLev=fLightLevel;
	glCullFace(GL_FRONT);
	glAlphaFunc(GL_NOTEQUAL,0.0f);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	_md2_drawModelg (model, iFrame,fLightLevel,fAlpha);
	if (wmodel)
	{	glBindTexture(GL_TEXTURE_2D,50000+g_a_iTexMD2[GlobalMD2Table[pSpr->state->MD2].iMD2]+1);
		_md2_drawModelg (wmodel, iFrame,fLightLevel,fAlpha);
	}
	//_md2_drawModel (model, iFrame,fLightLevel,fAlpha);
	//_md2_drawModel (wmodel, iFrame,fLightLevel,fAlpha);
	glCullFace(GL_BACK);
	glDisable(GL_BLEND);

	glPopMatrix();

	if (usecoronas&&((iCoronaIdx=GL_GenerateCorona(pSpr->type))!=-1))	// MR2007
	{ player_t *player;

		player=&players[consoleplayer];
		if (P_CheckSight(player->mo,pSpr))
		//while (GL_iGetDoomednum(iCoronaIdx)==pSpr->info->doomednum)
		while (GL_iGetType(iCoronaIdx)==pSpr->type)
		{	
			if (GL_ChechCoronaInSight(iCoronaIdx,player->mo,pSpr))
				GL_AddCorona(iCoronaIdx,xi,(float)pSpr->z/MAP_SCALE,zi,fLightLevel);
			iCoronaIdx++;
		}
	}
//#endif
}

void GL_vDrawMD2i(mobj_t *pSpr,float fLightLevel)	// interpolated
{ float xi,yi,zi,angle,fAlpha;
  int iFrame1,iFrame2;
  float fFrame1,fPol;
  md2_model_t *model,*wmodel;
  int iCoronaIdx;

//#ifdef DOOM_GL  frac
//#if defined(DOOM_GL) || defined(GL_HEXEN)
	model=Models[GlobalMD2Table[pSpr->state->MD2].iMD2];
	wmodel=WModels[GlobalMD2Table[pSpr->state->MD2].iMD2];
	if (pSpr->MD2tics<0)	// anti-bug...
		pSpr->MD2tics=0;
	/*iFrame=GlobalMD2Table[pSpr->state->MD2].iFirstFrame+
		(int)((float)(GlobalMD2Table[pSpr->state->MD2].iNbTics-pSpr->MD2tics)*
			  (float)(GlobalMD2Table[pSpr->state->MD2].iLastFrame-GlobalMD2Table[pSpr->state->MD2].iFirstFrame)/(float)GlobalMD2Table[pSpr->state->MD2].iNbTics);*/


	fFrame1=GlobalMD2Table[pSpr->state->MD2].iFirstFrame+
		((float)(GlobalMD2Table[pSpr->state->MD2].iNbTics-pSpr->MD2tics)*GlobalMD2Table[pSpr->state->MD2].fFrameTicFactor);
	iFrame1=(int)floor(fFrame1);
	iFrame2=iFrame1+1;
	//if (iFrame2>GlobalMD2Table[pSpr->state->MD2].iLastFrame)
	if (GlobalMD2Table[pSpr->state->MD2].iNbTics==1)
	{	fPol=0.0f;
		iFrame2=iFrame1;
	}
	else
		fPol=1.0f-(float)iFrame2+fFrame1;


	xi=-(float)pSpr->x/MAP_SCALE;
	//yi=((float)pSpr->z/*+(float)spritetopoffset[lump]*/)/MAP_SCALE/*+(float)3/(MAP_SCALE>>FRACBITS)*/;	// Why +2 ???
	//yi=(float)pSpr->z/MAP_SCALE+23.0f/MAP_COEFF;
	yi=(float)pSpr->z/MAP_SCALE+fMD2offset[GlobalMD2Table[pSpr->state->MD2].iMD2]/MAP_COEFF;	// 18
	zi=(float)pSpr->y/MAP_SCALE;

	angle=-180.0f+(float)(pSpr->angle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslatef(xi,yi,zi);
	glRotatef(angle,0.0f,1.0f,0.0f);

	//glBindTexture(GL_TEXTURE_2D,50000+GlobalMD2Table[pSpr->state->MD2].iMD2);
	glBindTexture(GL_TEXTURE_2D,50000+g_a_iTexMD2[GlobalMD2Table[pSpr->state->MD2].iMD2]);

	if(pSpr->flags&MF_SHADOW)
		//GL_StaticLight4f(fLightLevel,fLightLevel,fLightLevel,0.5f);
		fAlpha=0.5f;
	else
		//GL_StaticLight3f(fLightLevel,fLightLevel,fLightLevel);
		fAlpha=1.0f;

	// MR3006: DynLight
	cosA=cos(angle);
	sinA=sin(angle);
	xC=xi;
	yC=yi;
	zC=zi;
	//LightLev=fLightLevel;
	glCullFace(GL_FRONT);
	glAlphaFunc(GL_NOTEQUAL,0.0f);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	_md2_drawModelgi (model, iFrame1,iFrame2, fPol,fLightLevel,fAlpha);
	if (wmodel)
	{	glBindTexture(GL_TEXTURE_2D,50000+g_a_iTexMD2[GlobalMD2Table[pSpr->state->MD2].iMD2]+1);
		_md2_drawModelgi (wmodel, iFrame1,iFrame2, fPol,fLightLevel,fAlpha);
	}
	//_md2_drawModel (model, iFrame,fLightLevel,fAlpha);
	//_md2_drawModel (wmodel, iFrame,fLightLevel,fAlpha);
	glCullFace(GL_BACK);
	glDisable(GL_BLEND);

	glPopMatrix();

	if (usecoronas&&((iCoronaIdx=GL_GenerateCorona(pSpr->type))!=-1))	// MR2007
	{ player_t *player;

		player=&players[consoleplayer];
		if (P_CheckSight(player->mo,pSpr))
		//while (GL_iGetDoomednum(iCoronaIdx)==pSpr->info->doomednum)
		while (GL_iGetType(iCoronaIdx)==pSpr->type)
		{	
			if (GL_ChechCoronaInSight(iCoronaIdx,player->mo,pSpr))
				GL_AddCorona(iCoronaIdx,xi,(float)pSpr->z/MAP_SCALE,zi,fLightLevel);
			iCoronaIdx++;
		}
	}
//#endif
}

void md2_getAnimationFramesFromName (md2_model_t *model, char *animName, int *startFrame, int *endFrame)
{
	int i, j, pos;
	int count, numFrames, frameCount;
	int lastId;
	char name[16], last[16];

	/*strcpy (last, model->frames[0].name);
	pos = strlen (last) - 1;
	j = 0;
	while (last[pos] >= '0' && last[pos] <= '9' && j < 2)
	{
		pos--;
		j++;
	}
	last[pos + 1] = '\0';*/

	lastId = 0;
	count = 0;
	numFrames = 0;
	frameCount = 0;

	for (i = 0; i <= model->header.numFrames; i++)
	{
		if (i == model->header.numFrames)
			strcpy (name, ""); // some kind of a sentinel
		else
			strcpy (name, model->frames[i].name);
		pos = strlen (name) - 1;
		j = 0;
		while (name[pos] >= '0' && name[pos] <= '9' && j < 2)
		{
			pos--;
			j++;
		}
		name[pos + 1] = '\0';

		if (!lastId&&!stricmp (animName, name))
		{
			lastId=1;

			*startFrame = i;
		}
		if (lastId&&stricmp (animName, name))
		{
			*endFrame = i - 1;
			return;
		}
	}

	*startFrame = *endFrame = 0;
}


#define C_sz_MD2ini0	"md2.ini"
int iModel=0,iState=0,iCorresp=0,g_iNbMD2=0;
char C_sz_MD2ini[255];

typedef struct
{	char szState[64];
	int iState;
} tdstLkTable;

tdstLkTable *LkTable;

void fn_vReadStateSection(char *buffer)
{ char szBuffer[1024],*p_cBuffer,*p_cBuffer2=NULL;

	strcpy(LkTable[iState].szState,buffer);
	LkTable[iState].iState=iState;

	GlobalMD2Table[iState].iMD2=iModel;
	GetPrivateProfileString(buffer,"anim","-",szBuffer,1024,C_sz_MD2ini);
	strcpy(GlobalMD2Table[iState].name,szBuffer);
	GetPrivateProfileString(buffer,"NbTics","0",szBuffer,1024,C_sz_MD2ini);
	GlobalMD2Table[iState].iNbTics=atoi(szBuffer);
	GetPrivateProfileString(buffer,"StartFrame","0",szBuffer,1024,C_sz_MD2ini);
	GlobalMD2Table[iState].iFirstFrame=atoi(szBuffer);
	GetPrivateProfileString(buffer,"EndFrame","0",szBuffer,1024,C_sz_MD2ini);
	GlobalMD2Table[iState].iLastFrame=atoi(szBuffer);
	iState++;
}

void fn_vReadModelSection(char *buffer)
{ char szBuffer[1024],*p_cBuffer,*p_cBuffer2=NULL;

	GetPrivateProfileString(buffer,"file","-",szBuffer,1024,C_sz_MD2ini);
	if (szBuffer[0]=='-')
		return;
	MD2_FileName[iModel]=(char *)malloc(strlen(szBuffer)+1);
	strcpy(MD2_FileName[iModel],szBuffer);
	GetPrivateProfileString(buffer,"weapon","-",szBuffer,1024,C_sz_MD2ini);
	MD2_WFileName[iModel]=(char *)malloc(strlen(szBuffer)+1);
	strcpy(MD2_WFileName[iModel],szBuffer);
	GetPrivateProfileString(buffer,"offset","0.0",szBuffer,1024,C_sz_MD2ini);
	fMD2offset[iModel]=atof(szBuffer);
	GetPrivateProfileString(buffer,"scale","0.0",szBuffer,1024,C_sz_MD2ini);
	fMD2Scale[iModel]=atof(szBuffer);
	GetPrivateProfileString(buffer,"states","-",szBuffer,1024,C_sz_MD2ini);
	p_cBuffer=szBuffer;
	//while (*p_cBuffer!=0)
	while (1)
	{	p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		fn_vReadStateSection(p_cBuffer);
		if (p_cBuffer2)
			p_cBuffer=p_cBuffer2+1;
		else
			break;
	}
	iModel++;
}

int fn_iGetMD2State(char *szState)
{ int i;

	for (i=0;i<iState;i++)
		if (!strcmp(LkTable[i].szState,szState))
			return i;
	return -1;
}

void fn_vReadCorrespSection(char *buffer)
{ char szBuffer[1024],*p_cBuffer,*p_cBuffer2=NULL;

	GetPrivateProfileString("CORRESP",buffer,"-",szBuffer,1024,C_sz_MD2ini);
	//CorrespMD2Table[iCorresp].sprite=iCorresp;
	if (szBuffer[0]!='-')
	{	/*CorrespMD2Table[iCorresp].md2=fn_iGetMD2State(szBuffer);
		if (CorrespMD2Table[iCorresp].md2==-1)
			printf("Warning: szBuffer state undefined\n");*/
		p_cBuffer2=strpbrk(szBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		states[iCorresp+1].MD2=fn_iGetMD2State(szBuffer);
		if (states[iCorresp+1].MD2==-1)
			printf("Warning: MD2: %s state undefined\n",szBuffer);
		if (p_cBuffer2)
			states[iCorresp+1].tics=atoi(p_cBuffer2+1);
	}
	else
		states[iCorresp+1].MD2=-1;
	iCorresp++;
}

void MD2_vReadMD2ini()
{ char szBuffer[20480],*p_cBuffer;
  int i;

	if (!g_bMD2)
		return;

	if (g_bMD2Interpol)
		GL_vDrawMD2=GL_vDrawMD2i;
	else
		GL_vDrawMD2=GL_vDrawMD2g;

	GetCurrentDirectory(255,C_sz_MD2ini);
	strcat(C_sz_MD2ini,"\\");
	strcat(C_sz_MD2ini,C_sz_MD2ini0);

	LkTable=(tdstLkTable *)malloc(NUMMD2STATES*sizeof(tdstLkTable));
	
	GetPrivateProfileString("MD2","Nb","0",szBuffer,1024,C_sz_MD2ini);
	g_iNbMD2=atoi(szBuffer);
	g_a_iTexMD2=(int *)malloc(g_iNbMD2*sizeof(int));
	MD2_FileName=(char **)malloc(g_iNbMD2*sizeof(char *));
	MD2_WFileName=(char **)malloc(g_iNbMD2*sizeof(char *));
	fMD2offset=(float *)malloc(g_iNbMD2*sizeof(float));
	fMD2Scale=(float *)malloc(g_iNbMD2*sizeof(float));
	Models=(md2_model_t **)malloc(g_iNbMD2*sizeof(md2_model_t *));
	WModels=(md2_model_t **)malloc(g_iNbMD2*sizeof(md2_model_t *));
	for (i=0;i<g_iNbMD2;i++)
	{	Models[i]=(md2_model_t *)malloc(g_iNbMD2*sizeof(md2_model_t));
		WModels[i]=(md2_model_t *)malloc(g_iNbMD2*sizeof(md2_model_t));
	}
	
	GetPrivateProfileString("MD2",NULL,"-",szBuffer,1024,C_sz_MD2ini);
	p_cBuffer=szBuffer;
	p_cBuffer+=strlen(p_cBuffer)+1;
	while (*p_cBuffer!=0)
	{
		fn_vReadModelSection(p_cBuffer);
		p_cBuffer+=strlen(p_cBuffer)+1;
	}

	GetPrivateProfileString("CORRESP",NULL,"-",szBuffer,20480,C_sz_MD2ini);
	p_cBuffer=szBuffer;
	p_cBuffer+=strlen(p_cBuffer)+1;
	while (*p_cBuffer!=0)
	{
		fn_vReadCorrespSection(p_cBuffer);
		p_cBuffer+=strlen(p_cBuffer)+1;
	}

	free(LkTable);
}

void GL_vInitMD2Tables()
{ int i,j;
  md2_model_t *model;

//#ifdef DOOM_GL
//#if defined(DOOM_GL) || defined(GL_HEXEN)
	printf("OpenGL: Init MD2\n");

	for (j=0;j<NUMSTATES;j++)
		states[j].MD2=-1;

	MD2_vReadMD2ini();

	for (i=0;i<g_iNbMD2;i++)
	{	Models[i]=NULL;
		WModels[i]=NULL;
	}
	/*for (j=0;j<NB_CORRESP_STATES;j++)
		states[CorrespMD2Table[j].sprite].MD2=CorrespMD2Table[j].md2;*/

	for (i=0;i<iState;i++)
	{	if (!Models[GlobalMD2Table[i].iMD2])
		{	Models[GlobalMD2Table[i].iMD2]=md2_readModel(MD2_FileName[GlobalMD2Table[i].iMD2]);
			g_a_iTexMD2[g_iModel]=g_iTex-1;
			WModels[GlobalMD2Table[i].iMD2]=md2_readModel(MD2_WFileName[GlobalMD2Table[i].iMD2]);
			g_iModel++;
			if (Models[GlobalMD2Table[i].iMD2]==NULL)
				I_Error("Can't find %s\n",MD2_FileName[GlobalMD2Table[i].iMD2]);
		}
		model=Models[GlobalMD2Table[i].iMD2];
		if (GlobalMD2Table[i].iFirstFrame)
			continue;
		md2_getAnimationFramesFromName(model,GlobalMD2Table[i].name,&GlobalMD2Table[i].iFirstFrame,&GlobalMD2Table[i].iLastFrame);
		GlobalMD2Table[i].iNbTics=0;
		for (j=0;j<NUMSTATES;j++)
			if ((states[j].MD2==i)&&(states[j].tics!=-1))
				GlobalMD2Table[i].iNbTics+=states[j].tics;
		
		GlobalMD2Table[i].fFrameTicFactor=(float)(GlobalMD2Table[i].iLastFrame-GlobalMD2Table[i].iFirstFrame)/(float)GlobalMD2Table[i].iNbTics;
	}
//#endif
}

#if 0
void old_GL_vInitMD2Tables()
{ int i,j;
  md2_model_t *model;

//#ifdef DOOM_GL
#if defined(DOOM_GL) || defined(GL_HEXEN)
	MD2_vReadMD2ini();
	for (i=0;i<NB_MD2;i++)
		Models[i]=NULL;
	for (j=0;j<NUMSTATES;j++)
		states[j].MD2=MD2_INVALID;
	for (j=0;j<NB_CORRESP_STATES;j++)
		states[CorrespMD2Table[j].sprite].MD2=CorrespMD2Table[j].md2;

	for (i=0;i<NB_MD2_STATES;i++)
	{	if (!Models[GlobalMD2Table[i].iMD2])
		{	Models[GlobalMD2Table[i].iMD2]=md2_readModel(MD2_FileName[GlobalMD2Table[i].iMD2]);
			if (Models[GlobalMD2Table[i].iMD2]==NULL)
				I_Error("Can't find %s\n",MD2_FileName[GlobalMD2Table[i].iMD2]);
		}
		model=Models[GlobalMD2Table[i].iMD2];
		if (GlobalMD2Table[i].iFirstFrame)
			continue;
		md2_getAnimationFramesFromName(model,GlobalMD2Table[i].name,&GlobalMD2Table[i].iFirstFrame,&GlobalMD2Table[i].iLastFrame);
		GlobalMD2Table[i].iNbTics=0;
		for (j=0;j<NB_CORRESP_STATES;j++)
			if ((CorrespMD2Table[j].md2==i)&&(states[CorrespMD2Table[j].sprite].tics!=-1))
				GlobalMD2Table[i].iNbTics+=states[CorrespMD2Table[j].sprite].tics;
	}
#endif
}
#endif	// 0

GLboolean MD2_bIsASprite(int sprite,int frame)
{ int s;

//#ifdef DOOM_GL
#if defined(DOOM_GL) || defined(GL_HEXEN)
	if (!g_bMD2)
		return true;
	for (s=0;s<NUMSTATES;s++)
	{		if ((states[s].sprite==sprite)&&(states[s].frame==frame)&&(states[s].MD2==MD2_INVALID))
				return true;
	}
	return false;
#else
	return true;
#endif
}

#endif	// GL_HERETIC