// MR (USave)
#ifdef USAVE
#include "USApi.h"
#include "USApiDefs.h"
#endif

#include <windows.h>
#include <mmsystem.h>

extern int             ticcount;
#define TICRATE		35			// number of tics / second (Cf DoomDef.h)

int I_GetTime (void)
{
#ifdef NOTIMER
	ticcount++;
#else	// MR
    static DWORD startTime = 0;
    DWORD ms;

    ms = timeGetTime();
    if ( startTime == 0 )
        startTime = ms;
    ticcount = (int) (((ms - startTime) * TICRATE) / 1000);
    return ticcount;
#endif
	return(ticcount);
}
